"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _AuthScreenModule = _interopRequireDefault(require("./AuthScreen.module.scss"));

var _antd = require("antd");

require("antd/dist/antd.css");

var _SignupForm = _interopRequireDefault(require("../SignupForm/SignupForm"));

var _SigninForm = _interopRequireDefault(require("../SigninForm/SigninForm"));

var _Featuredescriptioncarousel = _interopRequireDefault(require("../Featuredescriptioncarousel/Featuredescriptioncarousel"));

require("./AuthScreen.css");

var _reactResponsive = require("react-responsive");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import Socialmediasignup from "../Socialmediasignup/Socialmediasignup";
const AuthScreen = props => {
  // let label = props.signup ? "Sign up with" : "Sign in with";
  const isDesktopOrLaptop = (0, _reactResponsive.useMediaQuery)({
    query: "(min-width: 980px)"
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _AuthScreenModule.default.AuthScreen
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "form-container"
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, null, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 24
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "fullsignup"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    className: "signin-options",
    span: 12
  }, props.signup && isDesktopOrLaptop && /*#__PURE__*/_react.default.createElement(_SignupForm.default, props), !props.signup && /*#__PURE__*/_react.default.createElement(_SigninForm.default, props)), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    className: "carousel",
    span: 12
  }, (props.signup || isDesktopOrLaptop) && /*#__PURE__*/_react.default.createElement(_Featuredescriptioncarousel.default, props)))))));
};

AuthScreen.propTypes = {
  storeToken: _propTypes.default.func,
  navigate: _propTypes.default.func,
  setUserDetails: _propTypes.default.func,
  realm: _propTypes.default.string,
  clientId: _propTypes.default.string,
  authhandlerUrl: _propTypes.default.string,
  backendUrl: _propTypes.default.string
};
AuthScreen.defaultProps = {
  storeToken: token => {
    // console.log("token", token);
    sessionStorage.setItem("access_token", token.access_token);
    sessionStorage.setItem("refresh_token", token.refresh_token);
  },
  navigate: to => {
    console.log("navigate to", to);
  },
  setUserDetails: to => {
    console.log("setUserDetails to", to);
  },
  realm: "test-realm-0",
  clientId: "test-realm-client",
  authhandlerUrl: "https://authhandler.dev.hcinbox.smarter.codes",
  backendUrl: "https://backend.dgraph.smarter.codes"
};
var _default = AuthScreen;
exports.default = _default;