"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.json.stringify.js");

var _freeRegularSvgIcons = require("@fortawesome/free-regular-svg-icons");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _antd = require("antd");

require("antd/dist/antd.css");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _constant = require("../constant");

require("./signinform.css");

var _SigninFormModule = _interopRequireDefault(require("./SigninForm.module.scss"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const SigninForm = _ref => {
  let {
    background,
    textColor,
    label,
    size,
    storeToken,
    navigate,
    setUserDetails,
    realm,
    clientId,
    authhandlerUrl,
    backendUrl
  } = _ref;
  const [username, setUsername] = (0, _react.useState)("");
  const [password, setPassword] = (0, _react.useState)("");
  const [isAuthenticate, setAuthenticationStatus] = (0, _react.useState)(undefined);
  const [loading, setLoading] = (0, _react.useState)(false);
  const [validationStatus, setValidationStatus] = (0, _react.useState)({
    signinemail: "",
    signinpassword: ""
  });
  const SIGNIN_API = "".concat(authhandlerUrl, "/auth/").concat(realm, "/").concat(clientId);

  const submitSignInForm = async () => {
    if (((username === null || username === void 0 ? void 0 : username.length) && (password === null || password === void 0 ? void 0 : password.length)) === 0 || [validationStatus.signinemail, validationStatus.signinpassword].includes("error")) {
      let tempstatus = _objectSpread({}, validationStatus);

      if ((username === null || username === void 0 ? void 0 : username.length) === 0) {
        tempstatus.signinemail = "error";
      }

      if ((password === null || password === void 0 ? void 0 : password.length) === 0) {
        tempstatus.signinpassword = "error";
      }

      setValidationStatus(tempstatus);
    } else {
      try {
        setLoading(true);
        const token = await fetch(SIGNIN_API, {
          method: "POST",
          headers: _constant.signinApiHeaders,
          body: JSON.stringify({
            username,
            password
          })
        });
        const tokenSet = await token.json();
        storeToken(tokenSet);
        setAuthenticationStatus(true);
        setLoading(false);
        navigate("/chat");
      } catch (error) {
        setLoading(false);
        setAuthenticationStatus(false);
        console.log(error);
      }
    }
  };

  const changeUsername = (0, _react.useCallback)(e => {
    setUsername(e.target.value);
  }, []);
  const changePassword = (0, _react.useCallback)(e => {
    setPassword(e.target.value);
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _SigninFormModule.default.SigninForm,
    "data-testid": "sign-in-form"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "signin-container"
  }, /*#__PURE__*/_react.default.createElement("h2", null, "Great to have you here"), /*#__PURE__*/_react.default.createElement(_antd.Form, {
    layout: "vertical",
    validateTrigger: "onBlur"
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    name: _constant.signinemailField,
    label: "Enter email",
    validateStatus: validationStatus.signinemail,
    rules: [{
      type: "regexp"
    }, (0, _constant.returnValidatorFor)(_constant.signinemailField, setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    value: username,
    onChange: changeUsername,
    className: size,
    placeholder: "example@gmail.com"
  })), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    name: _constant.signinpasswordField,
    label: "Password",
    validateStatus: validationStatus.signinpassword,
    rules: [{
      type: "regexp"
    }, (0, _constant.returnValidatorFor)(_constant.signinpasswordField, setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input.Password, {
    type: "password",
    value: password,
    onChange: changePassword,
    className: size,
    placeholder: "Password"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "signin-btn"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    style: {
      background: background,
      color: textColor
    },
    loading: loading,
    onClick: submitSignInForm
  }, label, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _freeRegularSvgIcons.faArrowAltCircleRight
  })))), isAuthenticate === false ? /*#__PURE__*/_react.default.createElement("div", {
    className: _SigninFormModule.default.alert
  }, /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Error",
    description: "Couldn\u2019t find a HCInbox account associated with this username.Please try again.",
    type: "error",
    showIcon: true
  })) : null)));
};

SigninForm.propTypes = {
  background: _propTypes.default.string,
  textColor: _propTypes.default.string,
  label: _propTypes.default.string,
  size: _propTypes.default.string
};
SigninForm.defaultProps = {
  background: "rgba(9, 109, 217, 1)",
  textColor: "white",
  label: "Sign in",
  size: "medium"
};
var _default = SigninForm;
exports.default = _default;