"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/es.json.stringify.js");

var _freeRegularSvgIcons = require("@fortawesome/free-regular-svg-icons");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _antd = require("antd");

require("antd/dist/antd.css");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _history = _interopRequireDefault(require("../../history"));

var _constant = require("../constant");

require("./signupform.css");

var _SignupFormModule = _interopRequireDefault(require("./SignupForm.module.scss"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const SignupForm = _ref => {
  let {
    background,
    textColor,
    label,
    size,
    storeToken,
    navigate,
    setUserDetails,
    realm,
    clientId,
    authhandlerUrl,
    backendUrl
  } = _ref;
  const [firstName, setFirstName] = (0, _react.useState)("");
  const [lastName, setLastName] = (0, _react.useState)("");
  const [email, setEmail] = (0, _react.useState)("");
  const [password, setPassword] = (0, _react.useState)("");
  const [isAuthenticate, setAuthenticationStatus] = (0, _react.useState)({
    status: false,
    message: ''
  });
  const [loading, setLoading] = (0, _react.useState)(false);
  const [validationStatus, setValidationStatus] = (0, _react.useState)({
    FirstName: "",
    LastName: "",
    email: "",
    password: ""
  });
  const SIGNUP_API = "".concat(authhandlerUrl, "/staff/signup");

  const submitSignupForm = async () => {
    let res = null;
    let userDetails = null;

    if (((firstName === null || firstName === void 0 ? void 0 : firstName.length) && (lastName === null || lastName === void 0 ? void 0 : lastName.length) && (email === null || email === void 0 ? void 0 : email.length) && (password === null || password === void 0 ? void 0 : password.length)) === 0 || [validationStatus.FirstName, validationStatus.LastName, validationStatus.email, validationStatus.password].includes("error")) {
      let tempstatus = {
        FirstName: "",
        LastName: "",
        email: "",
        password: ""
      };

      if ((firstName === null || firstName === void 0 ? void 0 : firstName.length) === 0) {
        tempstatus.FirstName = "error";
      }

      if ((lastName === null || lastName === void 0 ? void 0 : lastName.length) === 0) {
        tempstatus.LastName = "error";
      }

      if ((email === null || email === void 0 ? void 0 : email.length) === 0) {
        tempstatus.email = "error";
      }

      if ((password === null || password === void 0 ? void 0 : password.length) === 0) {
        tempstatus.password = "error";
      }

      setValidationStatus(tempstatus);
    } else {
      try {
        setLoading(false);

        const pathArr = _history.default.location.pathname.split('/');

        res = await fetch(SIGNUP_API, {
          method: "POST",
          headers: _constant.signinApiHeaders,
          body: JSON.stringify({
            name: "".concat(firstName, " ").concat(lastName),
            username: email,
            password: password,
            email: email,
            phone: "748596",
            invitationId: pathArr[pathArr.length - 1],
            organizationName: realm,
            clientId: clientId,
            organizationId: pathArr[pathArr.length - 2]
          })
        });

        if (!res.ok) {
          throw new Error(res);
        }

        const tokenSet = await res.json();
        storeToken(tokenSet);
        setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
          status: true,
          message: ''
        }));
        setLoading(false);
        navigate("/chat");
      } catch (error) {
        let msg;
        setLoading(false);

        if (userDetails !== null) {
          msg = await userDetails.json();
          setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
            status: false,
            message: 'Please signup with the correct Invitation ID'
          }));
        } else {
          msg = await res.json();
          setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
            status: false,
            message: msg.errorMessage
          }));
        }

        console.log(error);
      }
    }
  };

  const changeFirstName = (0, _react.useCallback)(e => {
    setFirstName(e.target.value);
  }, []);
  const changeLastName = (0, _react.useCallback)(e => {
    setLastName(e.target.value);
  }, []);
  const changeEmail = (0, _react.useCallback)(e => {
    setEmail(e.target.value);
  }, []);
  const changePassword = (0, _react.useCallback)(e => {
    setPassword(e.target.value);
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.SignupForm
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "signup-container"
  }, /*#__PURE__*/_react.default.createElement("h2", null, "Great to have you here"), /*#__PURE__*/_react.default.createElement(_antd.Form, {
    layout: "vertical",
    validateTrigger: "onBlur"
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "Name",
    gutter: [16]
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    name: "FirstName",
    label: "First Name",
    validateStatus: validationStatus.FirstName,
    rules: [{
      whitespace: false
    }, (0, _constant.returnValidatorForName)("FirstName", setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    className: size,
    value: firstName,
    onChange: changeFirstName,
    placeholder: "input first name"
  }))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    label: "Last Name",
    name: "LastName",
    validateStatus: validationStatus.LastName,
    rules: [{
      whitespace: false
    }, (0, _constant.returnValidatorForName)("LastName", setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    className: size,
    value: lastName,
    onChange: changeLastName,
    placeholder: "input last name"
  })))), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    name: _constant.emailField,
    label: "Enter email address",
    validateStatus: validationStatus.email,
    rules: [{
      type: "regexp"
    }, (0, _constant.returnValidatorFor)(_constant.emailField, setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    className: size,
    value: email,
    onChange: changeEmail,
    placeholder: "example@gmail.com"
  })), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    name: _constant.passwordField,
    label: "Password",
    value: password,
    onChange: changePassword,
    validateStatus: validationStatus.password,
    rules: [{
      type: "regexp"
    }, (0, _constant.returnValidatorFor)(_constant.passwordField, setValidationStatus, validationStatus)],
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input.Password, {
    className: size,
    placeholder: "Password"
  })), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "signup-btn"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    "data-testid": "sign-up-btn",
    style: {
      background: background,
      color: textColor
    },
    loading: loading,
    onClick: submitSignupForm // htmlType="submit"

  }, label, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
    icon: _freeRegularSvgIcons.faArrowAltCircleRight
  }))))), isAuthenticate.message.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.alert
  }, /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Error",
    description: isAuthenticate.message,
    type: "error",
    showIcon: true
  })) : null)));
};

SignupForm.propTypes = {
  background: _propTypes.default.string,
  textColor: _propTypes.default.string,
  label: _propTypes.default.string,
  size: _propTypes.default.string
};
SignupForm.defaultProps = {
  background: "rgba(9, 109, 217, 1)",
  textColor: "white",
  label: "Accept Invite",
  size: "medium"
};
var _default = SignupForm;
exports.default = _default;