"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Template = void 0;

var _SignupForm = _interopRequireDefault(require("./SignupForm"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable */
var _default = {
  title: "Signup/SignupForm-A customizable React SignupForm component",
  component: "SignupForm",
  argTypes: {
    background: {
      control: "color",
      description: "What button background color to use",
      type: {
        summary: "string"
      }
    },
    textColor: {
      control: "color",
      description: "What button text color to use",
      type: {
        summary: "string"
      }
    },
    label: {
      description: "Button contents",
      type: {
        summary: "text"
      }
    },
    size: {
      description: "Select size",
      control: {
        type: "select",
        options: ["small", "medium", "large"]
      }
    }
  }
};
exports.default = _default;

const Template = args => /*#__PURE__*/React.createElement(_SignupForm.default, args); //export const Default = Template.bind({});


exports.Template = Template;
Template.args = {
  background: "rgba(9, 109, 217, 1)",
  textColor: "white",
  label: "Accept Invite ",
  size: "medium"
};
Template.story = {
  name: "SignupForm"
};